var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { HeadProvider, Link, Meta as MetaPrimitive, Style, Title } from 'react-head';
import Body from './Body';
import Html from './Html';
import { extractTagsFrom, extractTitleFrom, renderStyles, renderTags } from './utils';
var MetaTagInverter = function (_a) {
    var rh = _a["data-rh"], others = __rest(_a, ['data-rh']);
    return _jsx("meta", __assign({}, others, { "data-rh": rh }), void 0);
};
var Meta = function (props) {
    // @ts-expect-error
    return _jsx(MetaPrimitive, __assign({}, props, { tag: MetaTagInverter }), void 0);
};
var Head = function (_a) {
    var bodyAttributes = _a.bodyAttributes, children = _a.children, htmlAttributes = _a.htmlAttributes, title = _a.title, _b = _a.meta, meta = _b === void 0 ? [] : _b, _c = _a.link, link = _c === void 0 ? [] : _c;
    var metaTagsToRender = extractTagsFrom({
        children: children,
        tag: 'meta',
        fallback: meta
    });
    var linkTagsToRender = extractTagsFrom({
        children: children,
        tag: 'link',
        fallback: link
    });
    var stylesTagsToRender = extractTagsFrom({
        children: children,
        tag: 'style'
    });
    // title is a special case, so we have the extract from the array
    // and simplify the fallback as used by the method
    var titleToRender = extractTitleFrom({
        children: children,
        fallback: title
    });
    return (_jsxs(_Fragment, { children: [titleToRender !== '' && _jsx(Title, { children: titleToRender }, void 0),
            renderTags({ tagsArray: metaTagsToRender, Component: Meta }),
            renderTags({ tagsArray: linkTagsToRender, Component: Link }),
            renderStyles({ stylesArray: stylesTagsToRender, Component: Style }),
            bodyAttributes != null && _jsx(Body, { attributes: bodyAttributes }, void 0),
            htmlAttributes != null && _jsx(Html, { attributes: htmlAttributes }, void 0)] }, void 0));
};
export { HeadProvider };
export default Head;
